/* ContinuousVariable class

 Constructing Intelligent Agents with Java
   (C) Joseph P.Bigus and Jennifer Bigus 1997
   
*/
package decisionTree;

import java.util.*;
import java.io.*;


class ContinuousVariable extends Variable {
float min = (float)0.0;
float max = (float)0.0;

ContinuousVariable(String name) { super(name); }
void setMin(float Min) { min = Min; }   
void setMax(float Max) { max = Max; }   


public void computeStatistics(String inValue){
    float val = new Float(inValue).floatValue();
    if (val < min) min = val ;
    if (val > max) max = val ;
} 

// scale the inValue to 0.0 and 1.0
public int normalize(String inStrValue, float[] outArray, int inx) {
    float outValue ;
    float inValue = Float.valueOf(inStrValue).floatValue();
    if (inValue <= min) { 
        outValue = min ;
    } else if (inValue >= max) {
        outValue = max ;
    } else {
       float factor = max - min ;
       outValue = inValue / factor ;
    }
    outArray[ inx] = outValue ;
    return inx+1 ;
}
  

};











